#include <stdio.h>
#include <stdlib.h>
#include <cairo.h>
#include <cairo-ft.h>
#include <ft2build.h>
#include <kos32sys.h>
#include FT_SFNT_NAMES_H
#include FT_FREETYPE_H
#include FT_GLYPH_H
#include FT_OUTLINE_H
#include FT_BBOX_H
#include FT_TYPE1_TABLES_H

int width  = 800;
int height = 500;

unsigned char *winbitmap;
int winstride;

void draw_window(){
        BeginDraw(); 
        DrawWindow(215,100,500, 500,"CAIRO",0xFFFFFF,0x33);
        EndDraw();
}

void newline(cairo_t *c, int x, int *y, int fontsize) {
	(*y) += fontsize;
	cairo_move_to (c, x, *y);
}

int main ()
{
    FT_Library value;
    FT_Error status;
    FT_Face face;

    cairo_t *c;
    cairo_surface_t *cs;
    cairo_font_face_t * ct;

    cs = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width, height);
    c = cairo_create (cs);

    const char * filename =
	"font.ttf";

    status = FT_Init_FreeType (& value);
    if (status != 0) {
		fprintf (stderr, "Error %d opening library.\n", status);
		exit (EXIT_FAILURE);
    }
    status = FT_New_Face (value, filename, 0, & face);
    if (status != 0) {
		fprintf (stderr, "Error %d opening %s.\n", status, filename);
		exit (EXIT_FAILURE);
    }
    ct = cairo_ft_font_face_create_for_ft_face (face, 0);
    cairo_set_font_face (c, ct);
    
    int x = 25, y = 50, font_size = 35;
    cairo_set_font_size (c, font_size);
    
    // SET BG COLOR
    cairo_set_source_rgb(c, 1, 1, 1);
    cairo_paint(c);
    
    cairo_set_source_rgb (c, 0, 0, 0);
    cairo_move_to (c, x, y);
    
    for (int i = 0; i<5; i++) {
		cairo_show_text (c, "TTF шрифты для Marker'а");
		font_size += 5;
		cairo_set_font_size (c, font_size);
		newline(c, x, &y, font_size);
	}
	    
    winstride = cairo_image_surface_get_stride(cs);
    winbitmap = cairo_image_surface_get_data(cs);
    
    #define evReDraw 1
	#define evKey 2
	#define evButton 3
	
    draw_window();
    Blit(winbitmap, TYPE_3_BORDER_WIDTH, get_skin_height(),
                 0, 0, width, height,width,height,winstride);
    while(1)
    {
		switch(get_os_event())
		{
			case evButton:
				if (get_os_button() == 1) exit(0);
				break;
		  
			case evKey:
				get_key();
				break;
			 
			case evReDraw:
				draw_window();
				Blit(winbitmap, TYPE_3_BORDER_WIDTH, get_skin_height(),
                 0, 0, width, height,width,height,winstride);
				break;
		}
    }
    
    cairo_destroy(c);
    cairo_surface_destroy(cs);
    return 0;
}
