#include <kos32sys.h>
#include <stdlib.h>
#include <string.h>
#include "kolibri_rasterworks.h"

/*
HOW TO USE RASTERWORKS

; параметры dd ffeewwhh
; hh = высота символа
; ww = ширина символа; 0 = авто (пропорционально)
; ee = кодировка; 1 = cp866, 2 = UTF-16LE, 3 = UTF-8
; ff = флаги; 0001 = полужирный, 0010 = курсив
; 0100 = подчеркивание, 1000 = перечеркнутый
; 00010000 = по правому краю, 00100000 = по центру
; 01000000 = установить текстовую область между верхней и нижней половинами 'x'
; 10000000 = холст 32bpp вместо 24bpp
; все флаги комбинируются, кроме выравнивания по правому краю + выравнивания по центру
*/


/* 
 EVENTS LOOK LIKE IN C--
*/

#define evReDraw 1
#define evKey 2
#define evButton 3
#define evMouse 6

/*
#define evReDraw  1
#define evKey     2
#define evButton  3
#define evExit    4
#define evDesktop 5
#define evMouse   6
#define evIPC     7
#define evNetwork 8
#define evDebug   9
*/

#define WIN_W 1300
#define WIN_H 750

char* title = "Marker v0.0";
int win_bg_color = 0x000825;

void Button() {
	int id = get_os_button();
	if (id == 1) exit(0);
}


void draw_window(){
        BeginDraw(); 
        DrawWindow(215,100,WIN_W,WIN_H,title,win_bg_color,0x33);
        
        EndDraw();
}

int main()
{
    kolibri_rasterworks_init();
    
    char* text = "HELLO!";
    void *buf = malloc(768*256*3 * sizeof(char));
	*((int*)buf) = 768;
	*((int*)buf+1) = 256;
	memset((char*)buf+8, (char)-1, 768*256*3);
	int len = countUTF8Z(text, -1);
	drawText(buf, 0, 0, text, len, 0xFFFF0000, 0x03031428);
	
    draw_window();
    
    while(1)
    {
		switch(get_os_event())
		{
			case evButton:
				Button();
				break;
		  
			case evKey:
				get_key();
				break;
			 
			case evReDraw:
				draw_window();
				DrawBitmap(buf+8, 0, 0, 768, 256);
				break;
			case evMouse:
				// NONE
				break;
		}
    }
}
