#include <kos32sys.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "kolibri_boxlib.h"
#include "scrollbar.h"
#include "event.h"
#include "winsize.h"

#define WIN_W 640
#define WIN_H 563

// DATA
char* title = "Marker v0.0";
int win_bg_color = 0x282c34;
scrollbar scroll_ver = {15, WIN_W - 26, WIN_H - 29, 0, 0, 2 /* type */, 115, 15, 0,0x353B47,0xD2CED0,0x555555,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1};
// END OF DATA

void Button() {
	int id = get_os_button();
	if (id == 1) exit(0);
}

void draw_window(){
        BeginDraw(); 
        DrawWindow(215,100,WIN_W,WIN_H,title,win_bg_color,0x33);
        scrollbar_v_draw(&scroll_ver);
        EndDraw();
}

void set_scroll_size() {
	scroll_ver.xpos = win_w_size() - 26;
	scroll_ver.ysize = win_h_size() - 29;
}

int main()
{
    kolibri_boxlib_init();
    
    SetMaskForEvents(EVM_REDRAW + EVM_KEY + EVM_BUTTON + EVM_MOUSE + EVM_MOUSE_FILTER);
	
    draw_window();
    // "kostyl" for true scrollbar drawing
    draw_window();
    
    while(1)
    {
		switch(get_os_event())
		{
			case evButton:
				Button();
				break;
		  
			case evKey:
				get_key();
				break;
			 
			case evReDraw:
				set_scroll_size();
				draw_window();
				break;
			case evMouse:
				scrollbar_v_mouse(&scroll_ver);
				break;
		}
    }
}
