// Includes //
#include <sys/kos.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include <render.h>

char* title = "Marker";
char* buffer;
int bw = 500, bh = 500;

void draw_window(){
	kos_BeginDraw(); 
	kos_DrawWindow(215, 100, 440, 440, title, 0x999999, 0x33);
	kos_DrawBitmap(buffer+8, 20, 20, bw, bh);
	kos_EndDraw();
}
void Button() {
	int id = kos_GetButtonID();
	if (id == 1) exit(0);
}

int main()
{
	RenderPen pen;
	render_Init(&pen);
	
	buffer = malloc(bw*bh*4+8);

	*((int*)buffer) = bw;
	*((int*)buffer+1) = bh;
	
	memset((char*)buffer+8, (char)-1, bw*bh*4);
	
	pen.font_size.x = 16;
	pen.font_size.y = 32;
	render_DrawTextLn(&pen, buffer, "It's simple MD viewer (yet no)");
	
	pen.color = 0x78007C;
	
	pen.font_size.x = 8;
	pen.font_size.y = 16;
	
	pen.style.italic = 1;
	render_DrawText(&pen, buffer, "Some words...");
	pen.style.italic = 0;
	render_DrawText(&pen, buffer, " Goodbye!");
	pen.style.italic = 1;
	render_DrawText(&pen, buffer, " wow.. italic!");
				
	while(1)
	{
		switch(kos_WaitForEvent())
		{
			case evButton:
				Button();
				break;
			case evReDraw:
				draw_window();				
				break;
		}
	}
}
