#include <kos32sys.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "kolibri_boxlib.h"
#include "scrollbar.h"
#include "event.h"
#include "winsize.h"
#include "font.h"

#define WIN_W 640
#define WIN_H 563

// DATA
char* title = "Marker v0.0";
int win_bg_color = 0x282c34;
scrollbar scroll_ver = {15, WIN_W - 26, WIN_H - 29, 0, 0, 2 /* type */, 1000, 200, 0,0x353B47,0xD2CED0,0x555555,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1};


// FONT DATA
int width  = 2000;
int height = 1000;
unsigned char *winbitmap;
int winstride;


void Button() {
	int id = get_os_button();
	if (id == 1) exit(0);
}

void draw_window(){
	BeginDraw(); 
	DrawWindow(215,100,WIN_W,WIN_H,title,win_bg_color,0x33);
	scrollbar_v_draw(&scroll_ver);
	EndDraw();
}

void set_scroll_size() {
	scroll_ver.xpos = win_w_size() - 26;
	scroll_ver.ysize = win_h_size() - 29;
}

int main()
{
    kolibri_boxlib_init();
    
    // FREETYPE AND CAIRO LOADING
    FT_Library value;
    FT_Error status;
    FT_Face face;

    cairo_t *c;
    cairo_surface_t *cs;
    cairo_font_face_t * ct;

    cs = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width, height);
    c = cairo_create (cs);

    const char* filename = "font.ttf";

    status = FT_Init_FreeType (& value);
    if (status != 0) {
		fprintf (stderr, "Error %d opening library.\n", status);
		exit (EXIT_FAILURE);
    }
    status = FT_New_Face (value, filename, 0, & face);
    if (status != 0) {
		fprintf (stderr, "Error %d opening %s.\n", status, filename);
		exit (EXIT_FAILURE);
    }
    ct = cairo_ft_font_face_create_for_ft_face (face, 0);
    cairo_set_font_face (c, ct);
    // END FT AND CAIRO LOADING
    
    
    // FONT CONFIG
    int x = 25, y = 50, font_size = 50;
    
    /////////// DRAW TEXT /////////////////
    
    cairo_set_font_size (c, font_size);
    
    // set BG color
    cairo_set_source_rgb(c, 1, 1, 1);
    cairo_paint(c);
    
    cairo_set_source_rgb (c, 0, 0, 0);
    cairo_move_to (c, x, y);
    
    for (int i = 0; i<15; i++) {
		cairo_show_text (c, "одинаковые строки...");
		newline(c, x, &y, font_size);
	}
	/////////// END DRAW TEXT /////////////////
	
	// Get drew data for BLIT    
    winstride = cairo_image_surface_get_stride(cs);
    winbitmap = cairo_image_surface_get_data(cs);
    
    
    
    SetMaskForEvents(EVM_REDRAW + EVM_KEY + EVM_BUTTON + EVM_MOUSE + EVM_MOUSE_FILTER);
    draw_window();
    // "kostyl" for true scrollbar drawing
    draw_window();
    
    while(1)
    {
		switch(get_os_event())
		{
			case evButton:
				Button();
				break;
		  
			case evKey:
				get_key();
				break;
			 
			case evReDraw:
				set_scroll_size();
				draw_window();
				DRAWBUF;
				break;
			case evMouse:
				scrollbar_v_mouse(&scroll_ver);
				DRAWBUF;
				break;
		}
    }
}
