#include <render.h>

int style_combine(bool italic, bool bold, bool underline, bool strike) {
	int style = 0;
	if (bold)   style += 1;
	if (italic) style += 2;
	if (underline) style += 4;
	if (strike) style += 8;
	return style;
}

void render_Init(RenderPen* pen) {
	kolibri_rasterworks_init();
	
	pen->color = 0x000000;
	pen->pos.x = 0;
	pen->pos.y = 0;
	pen->font_size.x = 8;
	pen->font_size.y = 16;
	pen->style.bold = 0;
	pen->style.italic = 0;
	pen->style.underline = 0;
	pen->style.strike = 0;
}

void render_DrawText(RenderPen* pen, char* buf, char* text) {
	int len = countUTF8Z(text, -1);
	drawText(buf, pen->pos.x, pen->pos.y, text, len, (0xFF<<24)+pen->color, ((style_combine(pen->style.italic, pen->style.bold, pen->style.underline, pen->style.strike)*0x100+0x03) * 0x100+pen->font_size.x)*0x100+pen->font_size.y);
	pen->pos.x += pen->font_size.x*len;
}

void render_NewLn(RenderPen* pen) {
	pen->pos.x = 0;
	pen->pos.y += pen->font_size.y;
}

void render_DrawTextLn(RenderPen* pen, char* buf, char* text) {
	render_DrawText(pen, buf, text);
	render_NewLn(pen);
}
