#pragma once

#include <stdbool.h>
#include <kolibri_rasterworks.h>

typedef struct{
	int x;
	int y;
} position_t;

typedef struct{
	bool italic;
	bool bold;
	bool underline;
	bool strike;
} style_t;

typedef struct{
	position_t pos; // Do not edit value in user-mode!!
	int color;
	position_t font_size;
	style_t style;
} RenderPen;

void render_Init(RenderPen* pen);
void render_DrawText(RenderPen* pen, char* buf, char* text);
void render_NewLn(RenderPen* pen);
void render_DrawTextLn(RenderPen* pen, char* buf, char* text);
